# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# perl_vendorlib/perl_vendorarch not defined by default prior to F-2
%{!?perl_vendorlib: %global perl_vendorlib %(eval "`perl -V:installvendorlib`"; echo $installvendorlib)}

Name:		perl-IO-Compress
Version:	2.049
Release:	1.%{__distinit}%{__distvers}
Summary:	Read and write compressed data
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/IO-Compress/
Source0:	http://search.cpan.org/CPAN/authors/id/P/PM/PMQS/IO-Compress-%{version}.tar.gz
Patch0:		IO-Compress-2.034-old-perl.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
BuildArch:	noarch
BuildRequires:	perl(Carp)
BuildRequires:	perl(Compress::Raw::Zlib) >= %{version}
BuildRequires:	perl(Compress::Raw::Bzip2) >= %{version}
BuildRequires:	perl(Config)
BuildRequires:	perl(Encode)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(Fcntl)
BuildRequires:	perl(File::Copy)
BuildRequires:	perl(File::Glob)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(List::Util)
BuildRequires:	perl(POSIX)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Symbol)
BuildRequires:	perl(Test::Pod)
BuildRequires:	perl(Test::NoWarnings)
%if %(perl -e 'print $] > 5.008000 ? 0 : 1;')
# RHL-9 / RHEL-3 perls are missing a dependency on /bin/csh, needed for glob()
BuildRequires:	/bin/csh
%endif
# This module obsoletes a lot of others
Obsoletes:	perl-Compress-Zlib < %{version}-%{release}
Provides:	perl-Compress-Zlib = %{version}-%{release}
Obsoletes:	perl-IO-Compress-Base < %{version}-%{release}
Provides:	perl-IO-Compress-Base = %{version}-%{release}
Obsoletes:	perl-IO-Compress-Zlib < %{version}-%{release}
Provides:	perl-IO-Compress-Zlib = %{version}-%{release}
Obsoletes:	perl-IO-Compress-Bzip2 < %{version}-%{release}
Provides:	perl-IO-Compress-Bzip2 = %{version}-%{release}

%description
This distribution provides a Perl interface to allow reading and writing of
compressed data created with the zlib and bzip2 libraries.

IO-Compress supports reading and writing of bzip2, RFC 1950, RFC
1951, RFC 1952 (i.e. gzip) and zip files/buffers.

The following modules used to be distributed separately, but are now
included with the IO-Compress distribution:
* Compress-Zlib
* IO-Compress-Zlib
* IO-Compress-Bzip2
* IO-Compress-Base

%prep
%setup -q -n IO-Compress-%{version}

# Remove spurious exec bits
chmod -x lib/IO/Uncompress/{Adapter/Identity,RawInflate}.pm

# File::Path 1.06 and earlier don't do rmtree properly enough for the test
# suite, so if that's what we've got, hack the test suite to use a local copy
# of File::Path 1.08 instead.
#
# Note that FC-3, FC-4, EL-4 have patched versions of File::Path 1.06 that work
# OK but we'll hack the test suite anyway since it's hard to tell if the
# module is patched.
%if %(perl -MFile::Path -e 'print $File::Path::VERSION <= 1.06 ? 1 : 0;')
%patch0 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install PERL_INSTALL_ROOT=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
find %{buildroot} -depth -type d -exec rmdir {} ';' 2>/dev/null
chmod -R u+w %{buildroot}

%check
# Use our hacked File::Path if necessary
[ -f inc/File/Path108.pm ] && export PERL5LIB=$(pwd)/inc

# Build using --with long_tests to enable long-running tests
# that can take around an hour to run on an i7
make test %{?_with_long_tests:COMPRESS_ZLIB_RUN_ALL=1}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{_bindir}/zipdetails
%{perl_vendorlib}/Compress/
%{perl_vendorlib}/File/
%dir %{perl_vendorlib}/IO/
%dir %{perl_vendorlib}/IO/Compress/
%doc %{perl_vendorlib}/IO/Compress/FAQ.pod
%{perl_vendorlib}/IO/Compress/Adapter/
%{perl_vendorlib}/IO/Compress/Base/
%{perl_vendorlib}/IO/Compress/Base.pm
%{perl_vendorlib}/IO/Compress/Bzip2.pm
%{perl_vendorlib}/IO/Compress/Deflate.pm
%{perl_vendorlib}/IO/Compress/Gzip/
%{perl_vendorlib}/IO/Compress/Gzip.pm
%{perl_vendorlib}/IO/Compress/RawDeflate.pm
%{perl_vendorlib}/IO/Compress/Zip/
%{perl_vendorlib}/IO/Compress/Zip.pm
%{perl_vendorlib}/IO/Compress/Zlib/
%{perl_vendorlib}/IO/Uncompress/
%{_mandir}/man1/zipdetails.1*
%{_mandir}/man3/Compress::Zlib.3pm*
%{_mandir}/man3/File::GlobMapper.3pm*
%{_mandir}/man3/IO::Compress::Base.3pm*
%{_mandir}/man3/IO::Compress::Bzip2.3pm*
%{_mandir}/man3/IO::Compress::Deflate.3pm*
%{_mandir}/man3/IO::Compress::FAQ.3pm*
%{_mandir}/man3/IO::Compress::Gzip.3pm*
%{_mandir}/man3/IO::Compress::RawDeflate.3pm*
%{_mandir}/man3/IO::Compress::Zip.3pm*
%{_mandir}/man3/IO::Uncompress::AnyInflate.3pm*
%{_mandir}/man3/IO::Uncompress::AnyUncompress.3pm*
%{_mandir}/man3/IO::Uncompress::Base.3pm*
%{_mandir}/man3/IO::Uncompress::Bunzip2.3pm*
%{_mandir}/man3/IO::Uncompress::Gunzip.3pm*
%{_mandir}/man3/IO::Uncompress::Inflate.3pm*
%{_mandir}/man3/IO::Uncompress::RawInflate.3pm*
%{_mandir}/man3/IO::Uncompress::Unzip.3pm*

%changelog
* Sat Feb 18 2012 Paul Howarth <paul@city-fan.org> - 2.049-1
- Update to 2.049
  - IO::Compress::Zip:
    - Error in t/cz-03zlib-v1.t that caused warnings with 5.15 (Perl RT#110736)

* Sun Jan 29 2012 Paul Howarth <paul@city-fan.org> - 2.048-1
- Update to 2.048
  - Set minimum zlib version to 1.2.0
  - IO::Compress test suite fails with Compress::Raw::Zlib 2.047 and zlib < 1.2.4
    (CPAN RT#74503)
- Drop workarounds for CPAN RT#74503

* Sun Jan 29 2012 Paul Howarth <paul@city-fan.org> - 2.047-1
- Update to 2.047
  - Set minimum Perl version to 5.6
  - IO::Compress::Zip:
    - In one-shot zip, set the Text Flag if "-T" thinks the file is a text file
    - In one-shot mode, wrote mod time and access time in wrong order in the
      "UT" extended field
- Resync Compress::Raw::* dependency versions
- Add buildreqs for core perl modules, which might be dual-lived
- Add patch to work around test failure with zlib < 1.2.4 (CPAN RT#74503)
- BR: perl(version), needed for work-around for CPAN RT#74503

* Mon Dec 19 2011 Paul Howarth <paul@city-fan.org> - 2.046-1
- Update to 2.046
  - Minor update to bin/zipdetails
  - Typo in name of IO::Compress::FAQ.pod
  - IO::Uncompress::Unzip:
    - Example for walking a zip file used eof to control the outer loop; this
      is wrong
  - IO::Compress::Zip:
    - Change default for CanonicalName to false (CPAN RT#72974)
- Freeze Compress::Raw::* dependency versions until next synchronized release

* Sun Dec  4 2011 Paul Howarth <paul@city-fan.org> - 2.045-1
- Update to 2.045
  - Restructured IO::Compress::FAQ.pod

* Sun Dec  4 2011 Paul Howarth <paul@city-fan.org> - 2.044-1
- Update to 2.044
  - Moved FAQ.pod under the lib directory so it can get installed
  - Added bin/zipdetails
  - In IO::Compress::Zip, in one-shot mode, enable Zip64 mode if the input
    file/buffer ≥ 0xFFFFFFFF bytes
  - Update IO::Compress::FAQ
- Use our own chmod incantation rather than the %%{_fixperms} macro to get the
  right permissions for the zipdetails script on old distributions

* Mon Nov 21 2011 Paul Howarth <paul@city-fan.org> - 2.043-1
- Update to 2.043
  - IO::Compress::Base:
    - Fixed issue that with handling of Zip files with two (or more) entries
      that were STORED; symptom is the first is uncompressed ok but the next
      will terminate early if the size of the file is greater than BlockSize
      (CPAN RT#72548)

* Fri Nov 18 2011 Paul Howarth <paul@city-fan.org> - 2.042-1
- Update to 2.042
  - IO::Compress::Zip:
    - Added exUnixN option to allow creation of the "ux" extra field, which
      allows 32-bit UID/GID to be stored
    - In one-shot mode use exUnixN rather than exUnix2 for the UID/GID
  - IO::Compress::Zlib::Extra::parseExtraField:
    - Fixed bad test for length of ID field (CPAN RT#72329, CPAN RT#72505)

* Sat Oct 29 2011 Paul Howarth <paul@city-fan.org> - 2.040-1
- Update to 2.040
  - t/105oneshot-zip-only.t:
    - CanonicalName test failure on Windows (CPAN RT#68926)
  - IO::Compress::Zip:
    - ExtAttr now populates MSDOS attributes

* Fri Oct 28 2011 Paul Howarth <paul@city-fan.org> - 2.039-1
- Update to 2.039
  - IO::Compress::Zip:
    - Added CanonicalName option (note this option is set to true by default)
    - Added FilterName option
  - IO::Uncompress::Base:
    - Fixed issue where setting $\ would corrupt the uncompressed data
  - t/050interop-*.t:
    - Handle case when external command contains a whitespace (CPAN RT#71335)

* Mon Jun 27 2011 Paul Howarth <paul@city-fan.org> - 2.037-2
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Wed Jun 22 2011 Paul Howarth <paul@city-fan.org> - 2.037-1
- Update to 2.037
  - IO::Uncompress:
    - Get globmapper tests working on VMS (CPAN RT#68926)
  - IO::Uncompress::Unzip:
    - Fixed limitation where Streamed Stored content was not supported

* Mon Jun 20 2011 Paul Howarth <paul@city-fan.org> - 2.036-1
- Update to 2.036
  - IO::Compress::Zip and IO::Uncompress::Unzip:
    - Added support for LZMA (method 14) compression/uncompression
      (this requires IO::Compress::Lzma to be installed)
  - IO::Compress::Unzip:
    - Fixed CRC issue when compression is Store or Bzip2 and Strict option is
      set
  - IO::Compress::Zip:
    - Fixed Zip64 issue where the content size is exactly 0xFFFFFFFF

* Sat May  7 2011 Paul Howarth <paul@city-fan.org> - 2.035-1
- Update to 2.035 (fix test failure on Windows - CPAN RT#67931)

* Tue May  3 2011 Paul Howarth <paul@city-fan.org> - 2.034-1
- Update to 2.034
  Compress::Zlib:
  - Silence pod warnings (CPAN RT#64876)
  - Removed duplicate words in pod
  IO::Compress::Base:
  - Fix failure of testsuite when being run in parallel (CPAN RT#56942)
  - Reduce symbol import
  - If the output buffer parameter passed to read has a value of undef, and
    Append mode was specified when the file was opened, and eof is reached,
    then the buffer paramer was left as undef; this is different from when
    Append isn't specified - the buffer parameter is set to an empty string
  - Fix issues with reading a file that contains an empty file that is
    compressed (CPAN RT#67554)
- Update patch for old File::Path versions
- Nobody else likes macros for commands

* Tue Jan  7 2011 Paul Howarth <paul@city-fan.org> - 2.033-1
- Update to 2.033 (fixed typos and spelling errors - Perl RT#81816)

* Fri Jan  7 2011 Paul Howarth <paul@city-fan.org> - 2.032-1
- Update to 2.032
  - IO::Uncompress::Base - fix handling of input files with valid headers but
    corrupt data, which would trigger an infinite loop when using the input
    line operator (CPAN RT#61915)
  - IO::Compress::Gzip - XFL default settings for max compression and fastest
    algorithm were the wrong way around
  - IO::Compress::Base::Common - fix precedence problem in parameter parsing
    code
- Use %%{_fixperms} macro instead of our own %%{__chmod} incantation

* Tue Sep 21 2010 Paul Howarth <paul@city-fan.org> - 2.030-2
- Add build option --with long_tests to enable long-running tests
- Include IO::Compress::FAQ (#634722, CPAN RT#61402)

* Mon Jul 26 2010 Paul Howarth <paul@city-fan.org> - 2.030-1
- Update to 2.030
  - IO::Compress::Zip - updates to documentation
  - IO::Compress::Zip - default value for ExtAttr on Unix changed to 0100644
  - IO::Uncompress::Unzip - reworked the "Name" option and examples in the pod
  - IO::Uncompress::Base - fixed problem with nextStream not returning 0

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 2.027-3
- Rebuild for perl 5.12.1 in Rawhide

* Sat Jun  5 2010 Paul Howarth <paul@city-fan.org> - 2.027-2
- Fix dist tag for RHEL-6 Beta

* Mon Apr 28 2010 Paul Howarth <paul@city-fan.org> - 2.027-1
- Update to 2.027
  - Compress::Zlib - remove autoload code from Zlib.pm (Perl RT#74088)

* Thu Apr  8 2010 Paul Howarth <paul@city-fan.org> - 2.026-1
- Update to 2.026
  - IO::Uncompress::Zip - some updates to documentation
  - IO::Uncompress::Zip - fixed default setting for ExtAttr
- Buildreq at least same versions of Compress::Raw::Zlib/Bzip2

* Sun Mar 28 2010 Paul Howarth <paul@city-fan.org> - 2.025-1
- Update to 2.025
  - IO::Uncompress::Unzip - The "Name" option wasn't documented
  - Allow zlib version check to be disabled (CPAN RT#54510)

* Mon Jan 11 2010 Paul Howarth <paul@city-fan.org> - 2.024-1
- Update to 2.024
  - Compress::Zlib - Get memGunzip & memGzip to set $gzerrno (CPAN RT#47283)
  - Compress::Zlib - Export memGunzip, memGzip and zlib_version (CPAN RT#52992)
  - examples/io/anycat - Use IO::Uncompress::AnyUncompress

* Mon Dec 21 2009 Paul Howarth <paul@city-fan.org> - 2.023-2
- Change obsoletes for old packages such that any version prior to this
  package's version/release is obsoleted, due to bogus versioned packages
  being present in Rawhide and screwing up the 2.015 obsoletes

* Mon Nov 30 2009 Paul Howarth <paul@city-fan.org> - 2.023-1
- Merge together perl-IO-Compress-Base, perl-Compress-Zlib,
  perl-IO-Compress-Zlib, and perl-IO-Compress-Bzip2 to form perl-IO-Compress
- Figure out why some of the tests fail on old distributions, and work
  around the problems
- Dist tag for Rawhide no longer needs special-casing

* Mon May  4 2009 Paul Howarth <paul@city-fan.org> - 2.015-1
- Import from Fedora
- Update to 2.015
- Clarify license as GPL version 1 or later, or Artistic (i.e. same as perl)
- Patch to make the module a regular one even on perl >= 5.9
- Disable globmapper test on RHL9, FC1, FC2 - it appears to tickle a perl bug
  that's fixed even in RHEL3

* Tue Jul 17 2007 Robin Norwood <rnorwood@redhat.com> - 2.005-2
- Bump release to beat F-7 version

* Sun Jul 01 2007 Robin Norwood <rnorwood@redhat.com> - 2.005-1
- Update to 2.005.

* Wed Mar 21 2007 Robin Norwood <rnorwood@redhat.com> - 2.004-1
- Fix some minor issues, and go to 2.004 from upstream

* Tue Feb 13 2007 Robin Norwood <rnorwood@redhat.com> - 2.003-1
- Specfile autogenerated by cpanspec 1.69.1.
